/*
 * Exchange Web Services Managed API
 *
 * Copyright (c) Microsoft Corporation
 * All rights reserved.
 *
 * MIT License
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this
 * software and associated documentation files (the "Software"), to deal in the Software
 * without restriction, including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED *AS IS*, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

import 'package:ews/Exceptions/ServiceLocalException.dart';

/// <summary>
/// Represents an exception that is thrown when the Autodiscover service could not be contacted.
/// </summary>
//    [Serializable]
class AutodiscoverLocalException extends ServiceLocalException {
  /// <summary>
  /// Initializes a new instance of the <see cref="AutodiscoverLocalException"/> class.
  /// </summary>
// AutodiscoverLocalException()
//            : super()
//        {
//        }

  /// <summary>
  /// Initializes a new instance of the <see cref="AutodiscoverLocalException"/> class.
  /// </summary>
  /// <param name="message">The message.</param>
  AutodiscoverLocalException([String message = ""]) : super(message) {}

  /// <summary>
  /// Initializes a new instance of the <see cref="AutodiscoverLocalException"/> class.
  /// </summary>
  /// <param name="message">The message.</param>
  /// <param name="innerException">The inner exception.</param>
// AutodiscoverLocalException.withMessageAndInnerException(String message, Exception innerException)
//            : super.(message, innerException)
//        {
//		}

  /// <summary>
  /// Initializes a new instance of the <see cref="T:Microsoft.Exchange.WebServices.Data.AutodiscoverLocalException"/> class with serialized data.
  /// </summary>
  /// <param name="info">The object that holds the serialized object data.</param>
  /// <param name="context">The contextual information about the source or destination.</param>
//		protected AutodiscoverLocalException(SerializationInfo info, StreamingContext context)
//			: super(info, context)
//		{
//		}
}
